<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: shoutbox_panel.php
| Author: Nick Jones (Digitanium)
| Co-Author: HaYaLeT web: http://www.hayaletsevgili.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }
add_to_head("<link rel='stylesheet' type='text/css' href='".INFUSIONS."shoutbox_panel/myshout.css' />");
add_to_head("<script type='text/javascript' src='".INFUSIONS."shoutbox_panel/js/reflection.js'></script>");

include_once INFUSIONS."shoutbox_panel/infusion_db.php";
include_once INCLUDES."infusions_include.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."shoutbox_panel/locale/English.php";
}

$shout_settings = get_settings("shoutbox_panel");

$link = FUSION_SELF.(FUSION_QUERY ? "?".FUSION_QUERY : "");
$link = preg_replace("^(&amp;|\?)s_action=(edit|delete)&amp;shout_id=\d*^", "", $link);
$sep = stristr($link, "?") ? "&amp;" : "?";
$shout_link = ""; $shout_message = "";

if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "delete") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
	if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."'"))) {
		$result = dbquery("DELETE FROM ".DB_SHOUTBOX." WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
	}
	redirect($link);
}

if (!function_exists("sbwrap")) {
	function sbwrap($text) {
		global $locale;

		$i = 0; $tags = 0; $chars = 0; $res = "";

		$str_len = strlen($text);

		for ($i = 0; $i < $str_len; $i++) {
			$chr = mb_substr($text, $i, 1, $locale['charset']);
			if ($chr == "<") {
				if (mb_substr($text, ($i + 1), 6, $locale['charset']) == "a href" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "img") {
					$chr = " ".$chr;
					$chars = 0;
				}
				$tags++;
			} elseif ($chr == "&") {
				if (mb_substr($text, ($i + 1), 5, $locale['charset']) == "quot;") {
					$chars = $chars - 5;
				} elseif (mb_substr($text, ($i + 1), 4, $locale['charset']) == "amp;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#39;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#92;") {
					$chars = $chars - 4;
				} elseif (mb_substr($text, ($i + 1), 3, $locale['charset']) == "lt;" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "gt;") {
					$chars = $chars - 3;
				}
			} elseif ($chr == ">") {
				$tags--;
			} elseif ($chr == " ") {
				$chars = 0;
			} elseif (!$tags) {
				$chars++;
			}

			if (!$tags && $chars == 18) {
				$chr .= "<br />";
				$chars = 0;
			}
			$res .= $chr;
		}

		return $res;
	}
}

openside($locale['SB_title']);
if (iMEMBER || $shout_settings['guest_shouts'] == "1") {
	include_once INCLUDES."bbcode_include.php";
	if (isset($_POST['post_shout'])) {
		$flood = false;
		if (iMEMBER) {
			$shout_name = $userdata['user_id'];
		} elseif ($shout_settings['guest_shouts'] == "1") {
			$shout_name = trim(stripinput($_POST['shout_name']));
			$shout_name = preg_replace("(^[+0-9\s]*)", "", $shout_name);
			if (isnum($shout_name)) { $shout_name = ""; }
			include_once INCLUDES."captchas/securimage/securimage.php";
			$securimage = new Securimage();
			if (!isset($_POST['sb_captcha_code']) || $securimage->check($_POST['sb_captcha_code']) == false) { redirect($link); }
		}
		$shout_message = str_replace("\n", " ", $_POST['shout_message']);
		$shout_message = preg_replace("/^(.{255}).*$/", "$1", $shout_message);
		$shout_message = trim(stripinput(censorwords($shout_message)));
		if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
			$comment_updated = false;
			if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."'"))) {
				if ($shout_message) {
					$result = dbquery("UPDATE ".DB_SHOUTBOX." SET shout_message='$shout_message' WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
				}
			}
			redirect($link);
		} elseif ($shout_name && $shout_message) {
			require_once INCLUDES."flood_include.php";
			if (!flood_control("shout_datestamp", DB_SHOUTBOX, "shout_ip='".USER_IP."'")) {
				$result = dbquery("INSERT INTO ".DB_SHOUTBOX." (shout_name, shout_message, shout_datestamp, shout_ip, shout_ip_type, shout_hidden) VALUES ('$shout_name', '$shout_message', '".time()."', '".USER_IP."', '".USER_IP_TYPE."', '0')");
			}
		}
		redirect($link);
	}
	if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
		$esresult = dbquery(
			"SELECT ts.shout_id, ts.shout_name, ts.shout_message, tu.user_id, tu.user_name
			FROM ".DB_SHOUTBOX." ts
			LEFT JOIN ".DB_USERS." tu ON ts.shout_name=tu.user_id
			WHERE ts.shout_id='".$_GET['shout_id']."'"
		);
		if (dbrows($esresult)) {
			$esdata = dbarray($esresult);
			if ((iADMIN && checkrights("S")) || (iMEMBER && $esdata['shout_name'] == $userdata['user_id'] && isset($esdata['user_name']))) {
				if ((isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
					$edit_url = $sep."s_action=edit&amp;shout_id=".$esdata['shout_id'];
				} else {
					$edit_url = "";
				}
				$shout_link = $link.$edit_url;
				$shout_message = $esdata['shout_message'];
			}
		} else {
			$shout_link = $link;
			$shout_message = "";
		}
	} else {
		$shout_link = $link;
		$shout_message = "";
	}

	echo "<a id='edit_shout' name='edit_shout'></a>\n";
	echo "<form name='shout_form' method='post' action='".$shout_link."'>\n";
	if (iGUEST) {
		echo $locale['SB_name']."<br />\n";
		echo "<input type='text' name='shout_name' value='' class='textbox' maxlength='30' style='width:176px' /><br />\n";
		echo $locale['SB_message']."<br />\n";
	}
echo "<table cellpadding='0' cellspacing='0' align='center' width='100%' class='shoutbg' style='margin:1px 0 2px 0;'><tr><td>";
	echo "<textarea name='shout_message' rows='4' cols='20' class='textbox' style='width:177px'>".$shout_message."</textarea>\n";
   echo "</td></tr></table>";
echo "<table cellpadding='0' cellspacing='0' align='center' width='100%' class='shoutbg' style='margin:1px 0 2px 0;'><tr><td>";
	echo display_bbcodes("120px;", "shout_message", "shout_form", "smiley|b|u|url|color")."\n</td><td>";
	echo "<input type='submit' name='post_shout' value='".$locale['SB_shout']."' class='button' />\n";

   echo "</td></tr></table>";
	if (iGUEST) {
		echo $locale['SB_validation_code']."<br />\n";
		echo "<img id='sb_captcha' src='".INCLUDES."captchas/securimage/securimage_show.php' alt='' /><br />\n";
		echo "<a href='".INCLUDES."captchas/securimage/securimage_play.php'><img src='".INCLUDES."captchas/securimage/images/audio_icon.gif' alt='' class='tbl-border' style='margin-bottom:1px' /></a>\n";
		echo "<a href='#' onclick=\"document.getElementById('sb_captcha').src = '".INCLUDES."captchas/securimage/securimage_show.php?sid=' + Math.random(); return false\"><img src='".INCLUDES."captchas/securimage/images/refresh.gif' alt='' class='tbl-border' /></a><br />\n";
		echo $locale['SB_enter_validation_code']."<br />\n<input type='text' name='sb_captcha_code' class='textbox' style='width:100px' /><br />\n";
	}
//echo "<table cellpadding='0' cellspacing='0' align='center'><tr><td>";
//	echo "<input type='submit' name='post_shout' value='".$locale['SB_shout']."' class='button' />\n";
//	echo "<input type='reset' name='reset' value='".$locale['SB_clear']."' class='button' />";
//    echo "</td></tr></table>";
    echo "</form>\n";
} else {
	echo "<div style='text-align:center'>".$locale['SB_login_req']."</div><br />\n";
}



$numrows = dbcount("(shout_id)", DB_SHOUTBOX, "shout_hidden='0'");
$result = dbquery(
	"SELECT ts.shout_id, ts.shout_name, ts.shout_message, ts.shout_datestamp, tu.user_id, tu.user_name, tu.user_status, tu.user_avatar, tu.user_location, tu.user_lastvisit
	FROM ".DB_SHOUTBOX." ts
	LEFT JOIN ".DB_USERS." tu ON ts.shout_name=tu.user_id
	WHERE shout_hidden='0'
	ORDER BY ts.shout_datestamp DESC LIMIT 0,".$shout_settings['visible_shouts']
);
if (dbrows($result)) {
	$i = 0;
	while ($data = dbarray($result)) {

  $lastseen = time() - $data['user_lastvisit'];
		if ($lastseen < 60) {
			$lastseensmall = "<img src='".INFUSIONS."shoutbox_panel/images/online.png' alt='online' title='online' /> <font color='#6BFF01'><b>Online</b></font>";
			$lastseen = "<img src='".INFUSIONS."shoutbox_panel/images/online.png' alt='online' title='online' /> <font color='#6BFF01'>Online!</font>";
		} elseif ($lastseen < 300)  {
			$lastseen = "<img src='".INFUSIONS."shoutbox_panel/images/soffline.png' alt='offline' title='offline' /> <font color='#FFA701'>Offline!</font>";
		} else {
			$lastseensmall = "<img src='".INFUSIONS."shoutbox_panel/images/offline.png' alt='offline' title='offline' /> <font color='#FF0000'><b>Offline</b></font>";
			$lastseen = "<img src='".INFUSIONS."shoutbox_panel/images/offline.png' alt='offline' title='offline' /> <font color='#FF0000'>Offline!</font>";
		}
echo "<table cellpadding='0' cellspacing='0' align='center' width='100%' ><tr><td>";
echo "<table cellpadding='0' cellspacing='0'><tr>";
	echo "<td style='padding:4px; border:1px solid #ddd;'>";
		if (!empty($data['user_avatar']) && file_exists(IMAGES."avatars/".$data['user_avatar'])){
		echo "<img style='height:40px; width:40px;' src='".IMAGES."avatars/".$data['user_avatar']."' alt='".$data['user_name']."' />";
		}else{
		echo "<img style='height:40px; width:40px;' src='".INFUSIONS."shoutbox_panel/images/noav.png' alt='".($data['user_name'] ? $data['user_name'] : $data['shout_name'])."' />";		
		}
    echo "</td>";
	echo "<td style='width:100%;height:50px;border-width:0; border-style:solid; border-color:#bbbbbb;'>";
		echo "<table cellpadding='0' cellspacing='0' style='padding:0 0 0 6px; width:100%; margin:0;height:50px; '>";
			echo "<tr><td class='shoutboxname'>";
			if ($data['user_name']) {
			echo "<span class='side'><img src='".INFUSIONS."shoutbox_panel/images/user.png' alt='user' title='user' /> ".profile_link($data['shout_name'], $data['user_name'], $data['user_status'])."</span>\n";
			} else {
			echo "<img src='".INFUSIONS."shoutbox_panel/images/user.png' alt='user' title='user' /> ".$data['shout_name']."\n";
			}
			echo "</td></tr>";
			echo "<tr><td class='shoutboxdate'>";
			echo "<img src='".INFUSIONS."shoutbox_panel/images/date.png' alt='date' title='date' /> ".showdate("forumdate", $data['shout_datestamp'])."";
			echo "</td></tr>";
			echo "<tr><td class='shoutboxdate'>";
            echo "".$lastseen."";
			echo "</td></tr>";
//			echo "<tr><td class='shoutboxdate'>";
//if ((iADMIN && checkrights("S")) || (iMEMBER && $data['shout_name'] == $userdata['user_id'] && isset($data['user_name']))) {
//			echo "<a href='".$link.$sep."s_action=edit&amp;shout_id=".$data['shout_id']."#edit_shout"."' class='side'>".$locale['SB_edit']."</a>::..\n";
//			echo "<a href='".$link.$sep."s_action=delete&amp;shout_id=".$data['shout_id']."' class='side'> ".$locale['SB_delete']."</a>::..<br />\n";
//		}
//			echo "</td></tr>";

		echo "</table>";
	echo "</td>";
echo "</tr></table>";
		echo "<div class='shoutbox' style='margin:4px 0 0 0;'><img src='".INFUSIONS."shoutbox_panel/images/comment.png' alt='comment' title='comment' /> ".sbwrap(parseubb(parsesmileys($data['shout_message']), "b|i|u|url|color"))."</div>\n";
	if ((iADMIN && checkrights("S")) || (iMEMBER && $data['shout_name'] == $userdata['user_id'] && isset($data['user_name']))) {
			echo "<a href='".$link.$sep."s_action=edit&amp;shout_id=".$data['shout_id']."#edit_shout"."' class='side'><img src='".INFUSIONS."shoutbox_panel/images/comment_edit.png' width='10' alt='comment' title='comment' border='0' /> ".$locale['SB_edit']."</a>::..\n";
			echo "<a href='".$link.$sep."s_action=delete&amp;shout_id=".$data['shout_id']."' class='side'><img src='".INFUSIONS."shoutbox_panel/images/comments_delete.png' width='10' alt='comment' title='comment' border='0' /> ".$locale['SB_delete']."</a>::..<br />\n";
	}

    echo "</td></tr></table>";
		$i++;
		if ($i != $numrows) { echo "<br />\n"; }
	}
	if ($numrows > $shout_settings['visible_shouts']) {
		echo "<div style='text-align:center'>\n<a href='".INFUSIONS."shoutbox_panel/shoutbox_archive.php' class='side'><img src='".INFUSIONS."shoutbox_panel/images/archive.png' alt='comment' title='comment' /> </a>\n</div>\n";
	}
} else {
	echo "<div>".$locale['SB_no_msgs']."</div>\n";
}
closeside();
?>
